import * as $protobuf from "protobufjs/minimal";

/** 시스템 에러 코드. */
export enum ErrorCode {
    /** 타임 아웃. */
    TIMEOUT = -1,
    /** 성공.*/
    SUCCESS = 0,
    /** 서버 시스템 에러. */
    SYSTEM_ERROR = 1
}
/** Connect 결과 코드. */
export enum ResultCodeConnect {
    /** 성공. */
    CONNECT_SUCCESS = 0,
    /** 실패. */
    CONNECT_FAIL = 1
}
/** Authenticate 결과 코드. */
export enum ResultCodeAuth {
    /** 성공. */
    AUTH_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    AUTH_FAIL_CONTENT = 201,
    /** 실패. 점검중. */
    AUTH_FAIL_MAINTENANCE = 202,
    /** 실패. 잘못된 AccountId. */
    AUTH_FAIL_INVALID_ACCOUNT_ID = 203
}
/** GetChannelInfo 결과 코드. */
export enum ResultCodeChannelInfo {
    /** 성공. */
    CHANNEL_INFO_SUCCESS = 0,
    /** 실패. 잘못된 서비스 아이디. */
    CHANNEL_INFO_FAIL_INVALID_SERVICEID = 1901
}
/** GetChannelList 결과 코드. */
export enum ResultCodeChannelList {
    /** 성공. */
    CHANNEL_LIST_SUCCESS = 0,
    /** 실패. 잘못된 서비스 아이디. */
    CHANNEL_LIST_FAIL_INVALID_SERVICEID = 1801
}
/** CreateRoom 결과 코드. */
export enum ResultCodeCreateRoom {
    /** 성공. */
    CREATE_ROOM_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    CREATE_ROOM_FAIL_CONTENT = 601,
    /** 실패. 이미 룸에 들어가 있음. */
    CREATE_ROOM_FAIL_ALREADY_JOINED_ROOM = 602
}
/** JoinRoom 결과 코드. */
export enum ResultCodeJoinRoom {
    /** 성공. */
    JOIN_ROOM_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    JOIN_ROOM_FAIL_CONTENT = 701,
    /** 실패. 방이 존재하지 않음. */
    JOIN_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 702,
    /** 실패. 이미 방에 들어가 있음. */
    JOIN_ROOM_FAIL_ALREADY_JOINED_ROOM = 703
}
/** LeaveRoom 결과 코드. */
export enum ResultCodeLeaveRoom {
    /** 성공. */
    LEAVE_ROOM_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    LEAVE_ROOM_FAIL_CONTENT = 801
}
/** 로그인 결과 코드. */
export enum ResultCodeLogin {
    /** 성공. */
    LOGIN_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    LOGIN_FAIL_CONTENT = 301,
    /** 실패. 노드가 존재하지 않음. */
    LOGIN_FAIL_NOT_EXIST_NODE = 302,
    /** 실패. 점검중. */
    LOGIN_FAIL_MAINTENANCE = 303,
    /** 실패. 게임서버가 응답하지 않음. */
    LOGIN_FAIL_TIMEOUT_GAME_SERVER = 304,
    /** 실패. 잘못된 서비스 아이디. */
    LOGIN_FAIL_INVALID_SERVICEID = 310,
    /** 실패. 잘못된 유저 타입. */
    LOGIN_FAIL_INVALID_USERTYPE = 311,
    /** 실패. 잘못된 유저 아이디. */
    LOGIN_FAIL_INVALID_USERID = 312,
    /** 실패. 잘못된 SubId. */
    LOGIN_FAIL_INVALID_SUB_ID = 313,
    /** 실패. 다른 서비스에 로그인 되어있음. */
    LOGIN_FAIL_LOGINED_OTHER_SERVICE = 320,
    /** 실패. 다른 채널에 로그인 되어있음. */
    LOGIN_FAIL_LOGINED_OTHER_CHANNEL = 321,
    /** 실패. 동일 Account 아이디로 다른 UserType이 로그인 되어있음. */
    LOGIN_FAIL_LOGINED_OTHER_USER_TYPE = 322,
    /** 실패. 동일 Account 아이디로 다른 DeviceId가 로그인 되어있음. */
    LOGIN_FAIL_LOGINED_OTHER_DEVICE = 323
}
/** Logout 결과 코드. */
export enum ResultCodeLogout {
    /** 성공. */
    LOGOUT_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    LOGOUT_FAIL_CONTENT = 401
}
/** MatchPartyCancel 결과 코드. */
export enum ResultCodeMatchPartyCancel {
    /** 성공. */
    MATCH_PARTY_CANCEL_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    MATCH_PARTY_CANCEL_FAIL_CONTENT = 1401,
    /** 실패. 파티매칭을 취소할 때, 룸이 파티매칭용 룸이 아닌경우. */
    MATCH_PARTY_CANCEL_FAIL_PARTY_MATCH_WEIRD = 1402
}
/** MatchPartyStart 결과 코드. */
export enum ResultCodeMatchPartyStart {
    /** 성공. */
    MATCH_PARTY_START_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    MATCH_PARTY_START_FAIL_CONTENT = 1301,
    /** 실패. 파티매칭을 요청할 때, 룸이 파티매칭용 룸이 아닌경우. */
    MATCH_PARTY_START_FAIL_PARTY_MATCH_WEIRD = 1302
}
/** MatchUserCancel 결과 코드. */
export enum ResultCodeMatchUserCancel {
    /** 성공. */
    MATCH_USER_CANCEL_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    MATCH_USER_CANCEL_FAIL_CONTENT = 1201,
    /** 실패. 이미 매칭이 이루어짐. */
    MATCH_USER_CANCEL_FAIL_ALREADY_JOINED_ROOM = 1202
}
/** MatchUserStart 결과 코드. */
export enum ResultCodeMatchUserStart {
    /** 성공. */
    MATCH_USER_START_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨 */
    MATCH_USER_START_FAIL_CONTENT = 1101,
    /** 실패. 이미 방에 들어가 있음. */
    MATCH_USER_START_FAIL_ALREADY_JOINED_ROOM = 1102
}
/** MatchUserDone 결과 코드. */
export enum ResultCodeMatchUserDone {
    /** 성공. */
    MATCH_USER_DONE_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨(조검에 맞는 방을 찾지 못함). */
    MATCH_USER_DONE_FAIL_CONTENT = 1501,
    /** 실패. 조건에 맞는 방을 찾아 방에 참가 시키는 도중, 방이 사라짐. */
    MATCH_USER_DONE_FAIL_ROOM_DOES_NOT_EXIST = 1502
}
/** MoveChannel 결과 코드. */
export enum ResultCodeMoveChannel {
    /** 성공. */
    MOVE_CHANNEL_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    MOVE_CHANNEL_FAIL_CONTENT = 1601,
    /** 실패. 체널 노드를 찾을 수 없음. */
    MOVE_CHANNEL_FAIL_NODE_NOT_FOUND = 1602,
    /** 실패. 이미 요청한 체널에 있음. */
    MOVE_CHANNEL_FAIL_ALREADY_JOINED_CHANNEL = 1603,
    /** 실패. 이미 방에 입장하여 체널 이동을 할 수 없음. */
    MOVE_CHANNEL_FAIL_ALREADY_JOINED_ROOM = 1604
}
/** Snapshot 결과 코드. */
export enum ResultCodeSnapshot {
    /** 성공. */
    SNAPSHOT_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    SNAPSHOT_FAIL_CONTENT = 501
}
/** MatchRoom 결과 코드. */
export enum ResultCodeMatchRoom {
    /** 성공. */
    MATCH_ROOM_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    MATCH_ROOM_FAIL_CONTENT = 901,
    /** 실패. 방이 존재하지 않음. */
    MATCH_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 902,
    /** 실패. 이미 방에 들어가 있음. */
    MATCH_ROOM_FAIL_ALREADY_JOINED_ROOM = 903,
    /** 실패. 방 이동 기능으로 매칭시킬 때, 기존방에서 나가기가 실패한 경우. */
    MATCH_ROOM_FAIL_LEAVE_ROOM = 904,
    /** 실패. 이미 매치 매이킹이 진행중인 경우. */
    MATCH_ROOM_FAIL_IN_PROGRESS = 905,
    /** 실패. 조건에 맞는 방을 찾아 방에 참가 시키는 도중, 방이 사라짐. */
    MATCH_ROOM_FAIL_MATCHED_ROOM_DOES_NOT_EXIST = 906
}
/** NamedRoom 결과 코드. */
export enum ResultCodeNamedRoom {
    /** 성공. */
    NAMED_ROOM_SUCCESS = 0,
    /** 실패. 컨텐츠에서 거부됨. */
    NAMED_ROOM_FAIL_CONTENT = 1001,
    /** 실패. 방 생성이 실패하여 방을 찾을 수 없음. */
    NAMED_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 1002,
    /** 실패. 이미 방에 들어가 있음. */
    NAMED_ROOM_FAIL_ALREADY_JOINED_ROOM = 1003
}
/** Disconnect가 된 이유 */
export enum ResultCodeDisconnect {
    /** 시스템 오류로 인한 강제 종료.
	     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 바람.*/
	    FORCE_CLOSE_SYSTEM_ERROR = 2000,
	    /** 서버에서 BaseConnection의 close() 호출 */
	    FORCE_CLOSE_BASE_CONNECTION = 2010,
	    /** 서버에서 BaseUser의 closeConnection() 호출 */
	    FORCE_CLOSE_BASE_USER = 2011,
	    /** Admin에서 강제 종료. */
	    FORCE_CLOSE_ADMIN_KICK = 2012,
	    /** 서버 점검으로 인한 강제 종료. */
	    FORCE_CLOSE_MAINTENANCE = 2020,
	    /** GameNode가 invalid 상태로 변경된 경우. */
	    FORCE_CLOSE_INVALID_NODE = 2021,
	    /** 유저 트렌스퍼가 실패한 경우. */
	    FORCE_CLOSE_USER_TRANSFER_FAIL = 2022,
	    /** 유저 트렌스퍼중 시스템 에러가 발생한 경우. */
	    FORCE_CLOSE_USER_TRANSFER_ERROR = 2023,
	    /** 인증 실패로 인한 강제 종료. */
	    FORCE_CLOSE_AUTHENTICATION_FAIL = 2030,
	    /** 중복접속으로 인한 강제 종료. */
	    FORCE_CLOSE_DUPLICATE_LOGIN = 2031,
	    /** 같은 계정 정보로 새로운 로그인 요청이 들어온 경우.
	     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 바람. */
	    FORCE_CLOSE_BY_NEW_CONNECTION = 2040,
	    /** 세션 정보를 찾을 수 없는 경우.
	     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 바람. */
	    FORCE_CLOSE_DISCONNECT_ALARM = 2041,
	    /** 클라이언트가 서버의 상태 체크에 응답을 하지 않은 경우.
	     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 바람.*/
	    FORCE_CLOSE_CHECK_CLIENT_STATE_FAIL = 2008,
	    /** 고스트 유저인 경우.
	     * 일반적으로 클라이언트에서 이 코드를 받을 일은 거의 없으며, 이 코드를 받았다면 GameAnvil 개발팀에 문의 바람.*/
	    FORCE_CLOSE_GHOST_USER = 2009,
	    /** 네트워크 연결이 끊어짐 */
	    SOCKET_DISCONNECT = 100,
	    /** 소켓 에러가 발생하여 연결을 끊음 */
	    SOCKET_ERROR = 101,
	    /** 타임아웃이 발생, 컨넥터에서 연결을 끊음 */
	    SOCKET_TIME_OUT = 102
}

export interface IMessage {
    className?: string;
    index?: number;
}

export namespace com {

    namespace nhn {

        namespace gameanvilcore {

            namespace protocol {

                enum TargetType {
                    GAME_USER = 0,
                    GATEWAY_CONNECTION = 1,
                    GATEWAY_SESSION = 2
                }

                interface IHeader extends IMessage {
                    errorCode?: (com.nhn.gameanvilcore.protocol.ErrorCode|null);
                    serviceId?: (number|null);
                    subId?: (number|null);
                    targetType?: (com.nhn.gameanvilcore.protocol.TargetType|null);
                    msgId?: (number|null);
                    seq?: (number|null);
                    uncompressSize?: (number|null);
                }

                class Header implements IHeader {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IHeader);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public errorCode: com.nhn.gameanvilcore.protocol.ErrorCode;
                    public serviceId: number;
                    public subId: number;
                    public targetType: com.nhn.gameanvilcore.protocol.TargetType;
                    public msgId: number;
                    public seq: number;
                    public uncompressSize: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IHeader): com.nhn.gameanvilcore.protocol.Header;
                    public static encode(message: com.nhn.gameanvilcore.protocol.Header, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.Header;
                }

                interface IPayload extends IMessage {
                    msgId?: (number|null);
                    data?: (Uint8Array|null);
                    priority?: (number|null);
                }

                class Payload implements IPayload {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IPayload);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public msgId: number;
                    public data: Uint8Array;
                    public priority: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IPayload): com.nhn.gameanvilcore.protocol.Payload;
                    public static encode(message: com.nhn.gameanvilcore.protocol.Payload, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.Payload;
                }

                interface IMultiMessage extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    reply?: (com.nhn.gameanvilcore.protocol.Payload|null);
                }

                class MultiMessage implements IMultiMessage {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMultiMessage);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public reply?: (com.nhn.gameanvilcore.protocol.Payload|null);
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMultiMessage): com.nhn.gameanvilcore.protocol.MultiMessage;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MultiMessage, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MultiMessage;
                }

                interface IPing extends IMessage {
                }

                class Ping implements IPing {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IPing);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IPing): com.nhn.gameanvilcore.protocol.Ping;
                    public static encode(message: com.nhn.gameanvilcore.protocol.Ping, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.Ping;
                }

                interface IPong extends IMessage {
                }

                class Pong implements IPong {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IPong);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IPong): com.nhn.gameanvilcore.protocol.Pong;
                    public static encode(message: com.nhn.gameanvilcore.protocol.Pong, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.Pong;
                }

                interface IClientStateCheck extends IMessage {
                }

                class ClientStateCheck implements IClientStateCheck {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IClientStateCheck);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IClientStateCheck): com.nhn.gameanvilcore.protocol.ClientStateCheck;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ClientStateCheck, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ClientStateCheck;
                }

                interface IClientStateOK extends IMessage {
                }

                class ClientStateOK implements IClientStateOK {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IClientStateOK);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IClientStateOK): com.nhn.gameanvilcore.protocol.ClientStateOK;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ClientStateOK, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ClientStateOK;
                }

                interface IAuthenticationReq extends IMessage {
                    accountId?: (string|null);
                    password?: (string|null);
                    deviceId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class AuthenticationReq implements IAuthenticationReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IAuthenticationReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public accountId: string;
                    public password: string;
                    public deviceId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IAuthenticationReq): com.nhn.gameanvilcore.protocol.AuthenticationReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.AuthenticationReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.AuthenticationReq;
                }

                interface IAuthenticationRes extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    userList?: (com.nhn.gameanvilcore.protocol.LoginedUserInfo[]|null);
                    message?: (string|null);
                    serviceIds?: ({ [k: string]: number }|null);
                }

                class AuthenticationRes implements IAuthenticationRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IAuthenticationRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public userList: com.nhn.gameanvilcore.protocol.LoginedUserInfo[];
                    public message: string;
                    public serviceIds: { [k: string]: number };
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IAuthenticationRes): com.nhn.gameanvilcore.protocol.AuthenticationRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.AuthenticationRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.AuthenticationRes;
                }

                interface ILoginReq extends IMessage {
                    subId?: (number|null);
                    channelId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    userType?: (string|null);
                }

                class LoginReq implements ILoginReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILoginReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public subId: number;
                    public channelId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public userType: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILoginReq): com.nhn.gameanvilcore.protocol.LoginReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LoginReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LoginReq;
                }

                interface ILoginRes extends IMessage {
                    userId?: (number|null);
                    userType?: (string|null);
                    channelId?: (string|null);
                    serviceId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    message?: (string|null);
                    isUserMatching?: (boolean|null);
                    isRelogined?: (boolean|null);
                    rejoinedRoomId?: (number|null);
                    rejoinedRoomName?: (string|null);
                    roomRejoinPayload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LoginRes implements ILoginRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILoginRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public userId: number;
                    public userType: string;
                    public channelId: string;
                    public serviceId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public message: string;
                    public isUserMatching: boolean;
                    public isRelogined: boolean;
                    public rejoinedRoomId: number;
                    public rejoinedRoomName: string;
                    public roomRejoinPayload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILoginRes): com.nhn.gameanvilcore.protocol.LoginRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LoginRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LoginRes;
                }

                interface ILoginedUserInfo extends IMessage {
                    subId?: (number|null);
                    serviceId?: (number|null);
                    userId?: (number|null);
                    userType?: (string|null);
                    channelId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LoginedUserInfo implements ILoginedUserInfo {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILoginedUserInfo);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public subId: number;
                    public serviceId: number;
                    public userId: number;
                    public userType: string;
                    public channelId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILoginedUserInfo): com.nhn.gameanvilcore.protocol.LoginedUserInfo;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LoginedUserInfo, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LoginedUserInfo;
                }

                interface ILogoutReq extends IMessage {
                    subId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LogoutReq implements ILogoutReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILogoutReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public subId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILogoutReq): com.nhn.gameanvilcore.protocol.LogoutReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LogoutReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LogoutReq;
                }

                interface ILogoutRes extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LogoutRes implements ILogoutRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILogoutRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILogoutRes): com.nhn.gameanvilcore.protocol.LogoutRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LogoutRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LogoutRes;
                }

                interface ISnapshotReq extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class SnapshotReq implements ISnapshotReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ISnapshotReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ISnapshotReq): com.nhn.gameanvilcore.protocol.SnapshotReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.SnapshotReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.SnapshotReq;
                }

                interface ISnapshotRes extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class SnapshotRes implements ISnapshotRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ISnapshotRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ISnapshotRes): com.nhn.gameanvilcore.protocol.SnapshotRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.SnapshotRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.SnapshotRes;
                }

                interface ICreateRoomReq extends IMessage {
                    roomType?: (string|null);
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class CreateRoomReq implements ICreateRoomReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ICreateRoomReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomType: string;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ICreateRoomReq): com.nhn.gameanvilcore.protocol.CreateRoomReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.CreateRoomReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.CreateRoomReq;
                }

                interface ICreateRoomRes extends IMessage {
                    roomId?: (number|null);
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class CreateRoomRes implements ICreateRoomRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ICreateRoomRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ICreateRoomRes): com.nhn.gameanvilcore.protocol.CreateRoomRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.CreateRoomRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.CreateRoomRes;
                }

                interface IJoinRoomReq extends IMessage {
                    roomId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    roomType?: (string|null);
                }

                class JoinRoomReq implements IJoinRoomReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IJoinRoomReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public roomType: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IJoinRoomReq): com.nhn.gameanvilcore.protocol.JoinRoomReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.JoinRoomReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.JoinRoomReq;
                }

                interface IJoinRoomRes extends IMessage {
                    roomId?: (number|null);
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class JoinRoomRes implements IJoinRoomRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IJoinRoomRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IJoinRoomRes): com.nhn.gameanvilcore.protocol.JoinRoomRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.JoinRoomRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.JoinRoomRes;
                }

                interface ILeaveRoomReq extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LeaveRoomReq implements ILeaveRoomReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILeaveRoomReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILeaveRoomReq): com.nhn.gameanvilcore.protocol.LeaveRoomReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LeaveRoomReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LeaveRoomReq;
                }

                interface ILeaveRoomRes extends IMessage {
                    roomId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class LeaveRoomRes implements ILeaveRoomRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.ILeaveRoomRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.ILeaveRoomRes): com.nhn.gameanvilcore.protocol.LeaveRoomRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.LeaveRoomRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.LeaveRoomRes;
                }

                interface IMatchRoomReq extends IMessage {
                    roomId?: (number|null);
                    create?: (boolean|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    roomType?: (string|null);
                    moveRoom?: (boolean|null);
                    leaveRoomPayload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchRoomReq implements IMatchRoomReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchRoomReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public create: boolean;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public roomType: string;
                    public moveRoom: boolean;
                    public leaveRoomPayload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchRoomReq): com.nhn.gameanvilcore.protocol.MatchRoomReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchRoomReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchRoomReq;
                }

                interface IMatchRoomRes extends IMessage {
                    created?: (boolean|null);
                    roomId?: (number|null);
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchRoomRes implements IMatchRoomRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchRoomRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public created: boolean;
                    public roomId: number;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchRoomRes): com.nhn.gameanvilcore.protocol.MatchRoomRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchRoomRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchRoomRes;
                }

                interface INamedRoomReq extends IMessage {
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                    roomType?: (string|null);
                    party?: (boolean|null);
                }

                class NamedRoomReq implements INamedRoomReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.INamedRoomReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public roomType: string;
                    public party: boolean;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.INamedRoomReq): com.nhn.gameanvilcore.protocol.NamedRoomReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.NamedRoomReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.NamedRoomReq;
                }

                interface INamedRoomRes extends IMessage {
                    created?: (boolean|null);
                    roomId?: (number|null);
                    roomName?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class NamedRoomRes implements INamedRoomRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.INamedRoomRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public created: boolean;
                    public roomId: number;
                    public roomName: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.INamedRoomRes): com.nhn.gameanvilcore.protocol.NamedRoomRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.NamedRoomRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.NamedRoomRes;
                }

                interface IMatchUserStartReq extends IMessage {
                    roomType?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchUserStartReq implements IMatchUserStartReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserStartReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomType: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserStartReq): com.nhn.gameanvilcore.protocol.MatchUserStartReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserStartReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserStartReq;
                }

                interface IMatchUserStartRes extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchUserStartRes implements IMatchUserStartRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserStartRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserStartRes): com.nhn.gameanvilcore.protocol.MatchUserStartRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserStartRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserStartRes;
                }

                interface IMatchPartyStartReq extends IMessage {
                    roomType?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchPartyStartReq implements IMatchPartyStartReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyStartReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomType: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyStartReq): com.nhn.gameanvilcore.protocol.MatchPartyStartReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchPartyStartReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchPartyStartReq;
                }

                interface IMatchPartyStartResOrNoti extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchPartyStartResOrNoti implements IMatchPartyStartResOrNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyStartResOrNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyStartResOrNoti): com.nhn.gameanvilcore.protocol.MatchPartyStartResOrNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchPartyStartResOrNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchPartyStartResOrNoti;
                }

                interface IMatchPartyCancelReq extends IMessage {
                    roomType?: (string|null);
                }

                class MatchPartyCancelReq implements IMatchPartyCancelReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyCancelReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomType: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyCancelReq): com.nhn.gameanvilcore.protocol.MatchPartyCancelReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchPartyCancelReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchPartyCancelReq;
                }

                interface IMatchPartyCancelResOrNoti extends IMessage {
                }

                class MatchPartyCancelResOrNoti implements IMatchPartyCancelResOrNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyCancelResOrNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchPartyCancelResOrNoti): com.nhn.gameanvilcore.protocol.MatchPartyCancelResOrNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchPartyCancelResOrNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchPartyCancelResOrNoti;
                }

                interface IMatchUserDone extends IMessage {
                    created?: (boolean|null);
                    roomId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MatchUserDone implements IMatchUserDone {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserDone);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public created: boolean;
                    public roomId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserDone): com.nhn.gameanvilcore.protocol.MatchUserDone;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserDone, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserDone;
                }

                interface IMatchUserTimeout extends IMessage {
                }

                class MatchUserTimeout implements IMatchUserTimeout {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserTimeout);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserTimeout): com.nhn.gameanvilcore.protocol.MatchUserTimeout;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserTimeout, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserTimeout;
                }

                interface IMatchUserCancelReq extends IMessage {
                    roomType?: (string|null);
                }

                class MatchUserCancelReq implements IMatchUserCancelReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserCancelReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomType: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserCancelReq): com.nhn.gameanvilcore.protocol.MatchUserCancelReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserCancelReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserCancelReq;
                }

                interface IMatchUserCancelRes extends IMessage {
                }

                class MatchUserCancelRes implements IMatchUserCancelRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMatchUserCancelRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMatchUserCancelRes): com.nhn.gameanvilcore.protocol.MatchUserCancelRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MatchUserCancelRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MatchUserCancelRes;
                }

                interface IMoveChannelReq extends IMessage {
                    channelId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MoveChannelReq implements IMoveChannelReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelReq): com.nhn.gameanvilcore.protocol.MoveChannelReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MoveChannelReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MoveChannelReq;
                }

                interface IMoveChannelRes extends IMessage {
                    channelId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MoveChannelRes implements IMoveChannelRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelRes): com.nhn.gameanvilcore.protocol.MoveChannelRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MoveChannelRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MoveChannelRes;
                }

                interface IGetChannelListReq extends IMessage {
                    serviceId?: (number|null);
                }

                class GetChannelListReq implements IGetChannelListReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetChannelListReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public serviceId: number;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetChannelListReq): com.nhn.gameanvilcore.protocol.GetChannelListReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetChannelListReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetChannelListReq;
                }

                interface IGetChannelListRes extends IMessage {
                    channelList?: (string[]|null);
                }

                class GetChannelListRes implements IGetChannelListRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetChannelListRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelList: string[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetChannelListRes): com.nhn.gameanvilcore.protocol.GetChannelListRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetChannelListRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetChannelListRes;
                }

                interface IGetChannelInfoReq extends IMessage {
                    serviceId?: (number|null);
                    channelId?: (string|null);
                }

                class GetChannelInfoReq implements IGetChannelInfoReq {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetChannelInfoReq);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public serviceId: number;
                    public channelId: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetChannelInfoReq): com.nhn.gameanvilcore.protocol.GetChannelInfoReq;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetChannelInfoReq, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetChannelInfoReq;
                }

                interface IGetChannelInfoRes extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class GetChannelInfoRes implements IGetChannelInfoRes {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IGetChannelInfoRes);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IGetChannelInfoRes): com.nhn.gameanvilcore.protocol.GetChannelInfoRes;
                    public static encode(message: com.nhn.gameanvilcore.protocol.GetChannelInfoRes, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.GetChannelInfoRes;
                }

                interface IForceLogoutNoti extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class ForceLogoutNoti implements IForceLogoutNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IForceLogoutNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IForceLogoutNoti): com.nhn.gameanvilcore.protocol.ForceLogoutNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ForceLogoutNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ForceLogoutNoti;
                }

                interface IForceCloseNoti extends IMessage {
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class ForceCloseNoti implements IForceCloseNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IForceCloseNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IForceCloseNoti): com.nhn.gameanvilcore.protocol.ForceCloseNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ForceCloseNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ForceCloseNoti;
                }

                interface IForceLeaveRoomNoti extends IMessage {
                    roomId?: (number|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class ForceLeaveRoomNoti implements IForceLeaveRoomNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IForceLeaveRoomNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public roomId: number;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IForceLeaveRoomNoti): com.nhn.gameanvilcore.protocol.ForceLeaveRoomNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.ForceLeaveRoomNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.ForceLeaveRoomNoti;
                }

                interface IMoveChannelNoti extends IMessage {
                    channelId?: (string|null);
                    payload?: (com.nhn.gameanvilcore.protocol.Payload[]|null);
                }

                class MoveChannelNoti implements IMoveChannelNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public channelId: string;
                    public payload: com.nhn.gameanvilcore.protocol.Payload[];
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IMoveChannelNoti): com.nhn.gameanvilcore.protocol.MoveChannelNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.MoveChannelNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.MoveChannelNoti;
                }

                interface INotice extends IMessage {
                    message?: (string|null);
                }

                class Notice implements INotice {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.INotice);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public message: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.INotice): com.nhn.gameanvilcore.protocol.Notice;
                    public static encode(message: com.nhn.gameanvilcore.protocol.Notice, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.Notice;
                }

                interface IAdminKickoutNoti extends IMessage {
                    message?: (string|null);
                }

                class AdminKickoutNoti implements IAdminKickoutNoti {
                    constructor(properties?: com.nhn.gameanvilcore.protocol.IAdminKickoutNoti);
                    public static className: string;
                    public static index: number;
                    public className: string;
                    public index: number;
                    public message: string;
                    public static create(properties?: com.nhn.gameanvilcore.protocol.IAdminKickoutNoti): com.nhn.gameanvilcore.protocol.AdminKickoutNoti;
                    public static encode(message: com.nhn.gameanvilcore.protocol.AdminKickoutNoti, writer?: $protobuf.Writer): $protobuf.Writer;
                    public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): com.nhn.gameanvilcore.protocol.AdminKickoutNoti;
                }

                enum ErrorCode {
                    SUCCESS = 0,
                    SYSTEM_ERROR = 1,
                    LOCATION_ERROR = 2,
                    MATCH_MAKE_ERROR = 3,
                    AUTH_SUCCESS = 0,
                    AUTH_FAIL_CONTENT = 201,
                    AUTH_FAIL_MAINTENANCE = 202,
                    AUTH_FAIL_INVALID_ACCOUNT_ID = 203,
                    LOGIN_SUCCESS = 0,
                    LOGIN_FAIL_CONTENT = 301,
                    LOGIN_FAIL_NOT_EXIST_NODE = 302,
                    LOGIN_FAIL_MAINTENANCE = 303,
                    LOGIN_FAIL_TIMEOUT_GAME_SERVER = 304,
                    LOGIN_FAIL_INVALID_SERVICEID = 310,
                    LOGIN_FAIL_INVALID_USERTYPE = 311,
                    LOGIN_FAIL_INVALID_USER_ID = 312,
                    LOGIN_FAIL_INVALID_SUB_ID = 313,
                    LOGIN_FAIL_LOGINED_OTHER_SERVICE = 320,
                    LOGIN_FAIL_LOGINED_OTHER_CHANNEL = 321,
                    LOGIN_FAIL_LOGINED_OTHER_USER_TYPE = 322,
                    LOGIN_FAIL_LOGINED_OTHER_DEVICE = 323,
                    LOGOUT_SUCCESS = 0,
                    LOGOUT_FAIL_CONTENT = 401,
                    SNAPSHOT_SUCCESS = 0,
                    SNAPSHOT_FAIL_CONTENT = 501,
                    CREATE_ROOM_SUCCESS = 0,
                    CREATE_ROOM_FAIL_CONTENT = 601,
                    CREATE_ROOM_FAIL_ALREADY_JOINED_ROOM = 602,
                    JOIN_ROOM_SUCCESS = 0,
                    JOIN_ROOM_FAIL_CONTENT = 701,
                    JOIN_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 702,
                    JOIN_ROOM_FAIL_ALREADY_JOINED_ROOM = 703,
                    LEAVE_ROOM_SUCCESS = 0,
                    LEAVE_ROOM_FAIL_CONTENT = 801,
                    MATCH_ROOM_SUCCESS = 0,
                    MATCH_ROOM_FAIL_CONTENT = 901,
                    MATCH_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 902,
                    MATCH_ROOM_FAIL_ALREADY_JOINED_ROOM = 903,
                    MATCH_ROOM_FAIL_LEAVE_ROOM = 904,
                    MATCH_ROOM_FAIL_IN_PROGRESS = 905,
                    MATCH_ROOM_FAIL_MATCHED_ROOM_DOES_NOT_EXIST = 906,
                    NAMED_ROOM_SUCCESS = 0,
                    NAMED_ROOM_FAIL_CONTENT = 1001,
                    NAMED_ROOM_FAIL_ROOM_DOES_NOT_EXIST = 1002,
                    NAMED_ROOM_FAIL_ALREADY_JOINED_ROOM = 1003,
                    NAMED_ROOM_FAIL_INVALID_ROOM_NAME = 1004,
                    MATCH_USER_START_SUCCESS = 0,
                    MATCH_USER_START_FAIL_CONTENT = 1101,
                    MATCH_USER_START_FAIL_ALREADY_JOINED_ROOM = 1102,
                    MATCH_USER_CANCEL_SUCCESS = 0,
                    MATCH_USER_CANCEL_FAIL_CONTENT = 1201,
                    MATCH_USER_CANCEL_FAIL_ALREADY_JOINED_ROOM = 1202,
                    MATCH_PARTY_START_SUCCESS = 0,
                    MATCH_PARTY_START_FAIL_CONTENT = 1301,
                    MATCH_PARTY_START_FAIL_PARTY_MATCH_WEIRD = 1302,
                    MATCH_PARTY_CANCEL_SUCCESS = 0,
                    MATCH_PARTY_CANCEL_FAIL_CONTENT = 1401,
                    MATCH_PARTY_CANCEL_FAIL_PARTY_MATCH_WEIRD = 1402,
                    MATCH_USER_DONE_SUCCESS = 0,
                    MATCH_USER_DONE_FAIL_CONTENT = 1501,
                    MATCH_USER_DONE_FAIL_ROOM_DOES_NOT_EXIST = 1502,
                    MOVE_CHANNEL_SUCCESS = 0,
                    MOVE_CHANNEL_FAIL_CONTENT = 1601,
                    MOVE_CHANNEL_FAIL_NODE_NOT_FOUND = 1602,
                    MOVE_CHANNEL_FAIL_ALREADY_JOINED_CHANNEL = 1603,
                    MOVE_CHANNEL_FAIL_ALREADY_JOINED_ROOM = 1604,
                    CHANNEL_LIST_SUCCESS = 0,
                    CHANNEL_LIST_FAIL_NO_CHANNEL_LIST = 1801,
                    CHANNEL_INFO_SUCCESS = 0,
                    CHANNEL_INFO_FAIL_NO_CHANNEL_INFO = 1901,
                    FORCE_CLOSE_SYSTEM_ERROR = 2000,
                    FORCE_CLOSE_BASE_CONNECTION = 2010,
                    FORCE_CLOSE_BASE_USER = 2011,
                    FORCE_CLOSE_ADMIN_KICK = 2012,
                    FORCE_CLOSE_MAINTENANCE = 2020,
                    FORCE_CLOSE_INVALID_NODE = 2021,
                    FORCE_CLOSE_USER_TRANSFER_FAIL = 2022,
                    FORCE_CLOSE_USER_TRANSFER_ERROR = 2023,
                    FORCE_CLOSE_AUTHENTICATION_FAIL = 2030,
                    FORCE_CLOSE_DUPLICATE_LOGIN = 2031,
                    FORCE_CLOSE_BY_NEW_CONNECTION = 2040,
                    FORCE_CLOSE_DISCONNECT_ALARM = 2041,
                    FORCE_CLOSE_CHECK_CLIENT_STATE_FAIL = 2042,
                    FORCE_CLOSE_GHOST_USER = 2043,
                    SOCKET_DISCONNECT = 2100,
                    SOCKET_TIME_OUT = 2101,
                    SOCKET_ERROR = 2102
                }
            }
        }
    }
}
import Base = com.nhn.gameanvilcore.protocol;
export { Base }

/**
 * Object을 Uint8Array(byte array)로 변환해주거나 Uint8Array를 Object로 변환해주는 유틸리티 클래스.
 */
export class JsonUtil {
    /**
     * Uint8Array을 Object로 변환.
     * @typeparam T Object의 타입
     * @param buffer 변환하고자 하는 Uint8Array
     */
    static Deserialize<T>(buffer: Uint8Array): T;
    /**
     * Object를 Uint8Array로 변환
     * @param object 변환하고자 하는 Object
     */
    static Serialize(object: any): Uint8Array;
}

/**
 * 서버와 주고 받는 모든 Message은 Packet에 실려서 처리 되며 Packet이 제공하는 인터페이스를 이용하게 된다.
 */
export class Packet {
    /**
     * Packet간의 우선순위(Priority)를 비교한다.
     * @param ap 비교할 Packet A
     * @param bp 비교할 Packet B
     * @return 우선 순위가 낮으면 -1, 같으면 0, 크면 1
     */
    static CompareTo(ap: Packet, bp: Packet): number;
    /**
     * 패킷을 복사한다.
     * @return 복사한 새 패킷
     */
    Clone(): Packet;
    /**
     * 입력받은 Message를 담은 패킷을 생성한다.
     * @param msg Message
     * @returns 생성한 패킷
     */
    static CreateFromPbMsg(msg: IMessage): Packet;
    /**
     * 임의의 Id와 Uint8Array(byte array)를 이용해 Packet을 생성한다.
     * @param msgIndex Packet을 구분하기위한 Id. 서버와 약속된 값이어야 한다.
     * @param buffer Packet에 담을 Uint8Array(byte array)
     * @returns 생성한 패킷
     */
    static CreateFromBuffer(msgIndex: number, buffer: Uint8Array): Packet;
    /**
     * 임의의 Id와 any 타입의 Object를 이용해 Packet을 생성한다.
     * 입력된 Object를 JSON스트링으로 변환하여 패킷에 담는다.
     * @param msgIndex Packet을 구분하기위한 Id. 서버와 약속된 값이어야 한다.
     * @param obj JSON스트링으로 변환할 임의의 Object
     * @returns 생성한 패킷
     */
    static CreateFromObject(msgIndex: number, obj: any): Packet;
    /**
     * 패킷에 담긴 Message를 꺼낸다.
     * @typeparam T 패킷에 담긴 Message의 타입
     * @returns Message. 패킷에 담긴 Message가 T가 아닐경우 null.
     */
    GetPbMessage<T extends IMessage>(): T;
    /**
     * 패킷에 담인 값을 임의의 Object로 변환해 리턴한다.
     * @returns 임의의 Object. 임의의 Id를 가진 패킷이 아닌경우 null을 리턴한다.
     */
    GetObject(): any;
    /**
     * 패킷의 우선순위(priority)를 리턴한다.
     */
    GetPriority(): number;
    /**
     * 패킷의 우선순위(priority)를 설정한다.
     * @param value 우선순위(priority)
     */
    SetPriority(value: number): void;
    /**
     * 패킷의 압축 여부를 리턴한다.
     */
    IsCompress(): boolean;
    /**
     * 패킷에 담긴 Uint8Array(byte array)를 리턴한다.
     */
    GetBytes(): Uint8Array;
    /**
     * 압축을 해제했을 경우 크기를 리턴한다.
     * 압축하지 않았을 경우 0.
     */
    GetUnCompressSize(): number;
    /**
     * 패킷을 압축한다.
     */
    Compress(): Packet;
    /**
     * 패킷의 압축을 해제한다.
     */
    Decompress(): Packet;
}

/**
 * Connector에서 사용할 프로토콜을 관리한다.
 * ProtoBuf를 지원하며 서버와 주고받는 모든 프로토콜은 미리 등록해야한다.
 */
export class ProtocolManager {
    /**
     * 사용할 프로토콜을 등록한다.
     * @param protocolId 등록할 프로토콜의 Id. 서버와 같은 값을 사용해야 한다. ( protocolId >= 0 && protocolId <= 510 )
     * @param protocol 등록할 프로토콜. 개별 Message가 아닌, 모든 Message를 가진 상위 객체를 등록해야한다.
     */
    static RegisterProtocol(protocolId: number, protocol: any): void;
    /**
     * 등록한 프로토콜을 등록 해제한다.
     * @param protocolId 등록 해제할 프로토콜의 Id
     */
    static UnregisterProtocol(protocolId: number): void;
    /**
     * Message의 프로토콜 Id를 리턴한다.
     * @param msg 확인하고자 하는 Message
     */
    static GetProtocolId<T extends IMessage>(msg: IMessage | (new () => T)): number;
    /**
     * Packet에 담긴 Message를 리턴한다.
     * 등록하지 않은 Message인 경우 null을 리턴한다.
     * @param target Message가 담긴 Packet
     * @returns Packet에 담긴 Message
     */
    static GetMessage(target: Packet): IMessage;
    /**
     * Packet에 담긴 Message의 이름을 리턴한다.
     * 등록하지 않은 Message인 경우 빈 문자열을 리턴한다.
     * @param target Message가 담긴 Packet
     * @returns Message의 이름.
     */
    static GetMessageName(target: Packet): string;
    /**
     * 입력받은 Message msg가 Packet에 담긴 Message와 같은 종류인지 비교한다.
     * @param msg 비교할 Message
     * @param target 비교할 Packet
     * @returns 같은 경우 true, 아닐경우 false
     */
    static IsProtocol(msg: IMessage, target: Packet): boolean;
}


/**
 * 여러개의 Packet을 담기 위한 Class.
 */
export class Payload {
    /**
     * Payload에 패킷을 추가한다.
     * @param packet 추가할 패킷
     */
    Add(packet: Packet): void;
    /**
     * Payload에 패킷 목록을 추가한다.
     * @param packetList 추가할 패킷의 Array
     */
    AddAll(packetList: Array<Packet>): void;
    /**
     * Payload에 담긴 패킷중 하나를 꺼낸다.
     * @param msgIndex 꺼낼 패킷의 임의의 Id.
     * @returns msgInde를 가진 패킷. 없을 경우 undefined
     */
    GetPacket(msgIndex: number): Packet;
    /**
     * Payload에 담긴 패킷중 하나를 꺼낸다.
     * @param msg 꺼낼 패킷의 MessageType
     * @returns msg를 가진 패킷. 없을 경우 undefined
     */
    GetPacket<T extends IMessage>(msg: new () => T): Packet;
    /**
     * Payload에 담긴 패킷중 원하는 패킷이 있는지 확인한다.
     * @param msgIndex 확인할 패킷의 임의의 Id.
     * @returns 있을 경우 true. 없을 false
     */
    Contains(msgIndex: number): boolean;
    /**
     * Payload에 담긴 패킷중 원하는 패킷이 있는지 확인한다.
     * @param msg 확인할 패킷의 MessageType.
     * @returns 있을 경우 true. 없을 false
     */
    Contains<T extends IMessage>(msg: new () => T): boolean;
    /**
     * Payload에 담긴 패킷중에서 Message를 꺼낸다.
     * @param msg 꺼낼 MessageType
     */
    GetPBMessage<T extends IMessage>(msg: new () => T): T;
    /**
     * Payload에 담긴 패킷중에서 임의의 Object를 꺼낸다.
     * @param msgIndex Object가 담긴 패킷의 임의의 Id
     */
    GetObject(msgIndex: number): any;
    /**
     * 빈 Payload를 생성한다.
     * @returns 생성한 Payload
     */
    static CreateEmpty(): Payload;
    /**
     * Message를 담은 패킷 한개를 추가한 Payload를 생성한다.
     * @returns 생성한 Payload
     */
    static CreateFromPbMSg(msg: IMessage): Payload;
    /**
     * 임의의 Id와 Uint8Array(byte array)를 담은 Packet을 패킷 한개를 추가한 Payload를 생성한다.
     * @returns 생성한 Payload
     */
    static CreateFromBuffer(msgIndex: number, buffer: Uint8Array): Payload;
    /**
     * 임의의 Id와 any 타입의 Object를 담은 Packet을 패킷 한개를 추가한 Payload를 생성한다.
     * @returns 생성한 Payload
     */
    static CreateFromObject(msgIndex: number, obj: any): Payload;
}

/**
 * 내부용 이므로 사용하면 안된다.
 */
export class InternalPacket {
    static CompareTo(a: InternalPacket, b: InternalPacket): number;
    static CreateFromPayload(payload: Base.Payload): InternalPacket;
    static CreateFromPayloads(payloads: Array<Base.Payload>): Array<InternalPacket>;
    static CreateFromPackets(packets: Array<Packet>): InternalPacket;
    static CreateFromPbMsg(msg: IMessage): InternalPacket;
    static CreateFromPacket(packet: Packet): InternalPacket;
    Clone(): InternalPacket;
    SetServiceId(value: number): void;
    GetServiceId(): number;
    GetSubId(): number;
    SetSubId(value: number): void;
    GetMsgId(): number;
    GetBytes(): Uint8Array;
    GetPacket(): Packet;
    SetSeq(value: number): void;
    GetSeq(): number;
    IsMultiMessage(): boolean;
}

/**
 * 내부용 이므로 사용하면 안된다.
 */
export class ResultCodeUtil {
    static toResultCode<E>(errorCode: Base.ErrorCode): E;
    static toErrorCode(resultCode: any): Base.ErrorCode;
}

/**
 * 내부용 이므로 사용하면 안된다.
*/
export class EventCallback {
    constructor(isVolatile: boolean);
    Clear(): void;
    Add(cmdName: string, callback: any): void;
    Remove(cmdName: string): void;
    Has(cmdName: string): boolean;
    Call(cmdName: string, arg1: any, arg2?: any, arg3?: any, arg4?: any, arg5?: any, arg6?: any, arg7?: any, arg8?: any): void;
}


/**
 * 내부용 이므로 사용하면 안된다.
*/
export class EventCallbackByMsgId {
    constructor(isVolatile: boolean);
    Clear(): void;
    Add<T extends IMessage>(msg: IMessage | (new () => T), callback: any): void;
    AddWithMsgId(msgId: number, callback: any): void;
    Remove<T extends IMessage>(msg: IMessage | (new () => T)): void;
    RemoveWithMsgId(msgId: number): void;
    Has(msgId: number): boolean;
    Call(msgId: number, arg1: any, arg2?: any, arg3?: any, arg4?: any, arg5?: any, arg6?: any, arg7?: any, arg8?: any): void;
}

/**
 * GameAnvil Server의 Space Node와 관련된 작업을 담당한다.
 * 로그인(Login()), 로그아웃(Logout()) 및 Room 관리 등 기본 기능을 제공하며, 서버 구현에 따라 사용자 정의 기능을 추가적으로 제공할 수도 있다.
 * UserAgent를 사용하기 위해서는 Connector.CreateUserAgent() 함수를 이용해 새로운 UserAgent를 생성해야 한다.
 * ServiceName 과 SubId로 구분되는 여러개의 UserAgent를 생성할 수 있으며 생성된 각 UserAgent는 독립적으로 사용할 수 있다.
 * 생성된 UserAgent는 Connector 에서 내부적으로 관리되며 Connector.GetUser()함수를 이용해 다시 사용할 수 있다.
 *
 * UserAgent의 기본 기능 사용
 * UserAgent가 제공하는 기본 기능은 모두 비동기 함수를 통해 제공된다.
 * 그리고 각 기능의 결과를 얻기 위해 크게 나눠 2가지 방식을 제공하고 있다.
 * 첫째는 listener나 delegate를 미리 등록해 놓고 이를 통해 결과에 대한 알림을 받는 방법이고 나머지는 기능을 요청 할 때 알림을 받을 delegate를 같이 전달하는 방법이다.
 * 두가지 방법을 같이 사용하는 것도 가능하고 목적에 따라 listener나 delegate를 여러개 등록하여 사용할 수도 있다.
 */
export class UserAgent {
    /**
     * 로그인 여부를 확인한다.
     * @returns 로그인 한경우 true, 아닐경우 false
     */
    IsLogin(): boolean;
    /**
     * 인증시 사용한 AccountId를 리턴한다.
     * @returns 인증시 사용한 AccountId
     */
    GetAccountId(): string;
    /**
     * 로그인한 서비스의 ServiceName을 리턴한다.
     * @returns 로그인한 서비스의 ServiceName
     */
    GetServiceName(): string;
    /**
     * 로그인한 UserType을 리턴한다.
     * @returns 로그인한 UserType
     */
    GetUserType(): string;
    /**
     * 로그인한 SubId를 리턴한다.
     * @returns 로그인한 SubId
     */
    GetSubId(): number;
    /**
     * UserId를 리턴한다.
     * @returns UserId
    */
    GetUserId(): number;
    /**
     * 로그인한 체널의 ChannelId를 리턴한다.
     * @returns 로그인한 체널의 ChannelId
    */
    GetChannelId(): string;
    /**
     * 임의의 데이터를 설정한다.
     * @param userData 임의의 데이터
     */
    SetUserData(userData: any): void;
    /**
     * SetUserData()로 설정한 임의의 데이터를 리턴한다.
     * @returns 설정된 임의의 데이터
     */
    GetUserData(): any;
    /**
     * 임의의 Id에 대한 callback을 등록한다.
     * 해당 Id의 패킷을 수신한 경우 등록된 callback이 호출된다.
     * @param resMsgIndex 응답으로 받을 패킷의 임의의 Id
     * @param callback callback
     */
    AddUndefinedProtocolCallback(resMsgIndex: number, callback: (agent: UserAgent, packet: Packet) => void): void;
    /**
     * 임의의 Id에 대해 등록한 모든 callback을 등록 해제한다.
     * @param resMsgIndex 등록한 임의의 Id
     */
    RemoveUndefinedProtocolCallback(resMsgIndex: number): void;
    /**
     * 특정 Message에 대한 callback을 등록한다.
     * 특정 Message의 패킷을 수신한 경우 등록된 callback이 호출된다.
     * @param message 응답으로 받을 패킷에 담긴 Message
     * @param callback callback
     */
    AddCallback<T extends IMessage>(message: new () => T, callback: (agent: UserAgent, msg: T) => void): void;
    /**
     * 특정 Message에 대해 등록한 모든 callback을 등록 해제한다.
     * @param message 등록한 Message
     */
    RemoveCallback<T extends IMessage>(message: new () => T): void;
    /**
     * 등록한 모든 callback을 등록 해제한다.
     */
    RemoveAllCallback(): void;
    /**
     * IUserListener를 상속받은 UserListener를 등록한다.
     * @param listener IUserListener를 상속받은 UserListener
     */
    AddListener(listener: IUserListener): void;
    /**
     * 등록한 UserListener를 등록 해제한다.
     * @param listener 등록한 UserListener
     */
    RemoveListener(listener: IUserListener): void;
    /**
     * 서버로 Packet Array를 보낸다
     * @param packets 서버로 보낼 Packet Array
     */
    MultiSend(packets: Array<Packet>): void;
    /**
     * 서버의 Session으로 Packet Array를 보낸다
     * @param packets 서버로 보낼 Packet Array
     */
    MultiSendToGatewaySession(packets: Array<Packet>): void;
    /**
     * 서버로 Packet을 보낸다
     * @param packet 서버로 보낼 패킷
     */
    Send(packet: Packet): void;
    /**
     * 서버의 Session으로 Packet을 보낸다
     * @param packet 서버로 보낼 패킷
     */
    SendToGatewaySession(packet: Packet): void;
    /**
     * 서버로 Message를 담은 패킷 보낸다.
     * @param reqMsg 서버로 보낼 Message
     */
    SendPb<T extends IMessage>(reqMsg: IMessage): void;
    /**
     * 서버의 Session으로 Message를 담은 패킷 보낸다.
     * @param reqMsg 서버로 보낼 Message
     */
    SendPbToGatewaySession<T extends IMessage>(reqMsg: IMessage): void;
    /**
     * 서버로 Packet Array를 보내고, 응답을 기다린다.
     * 응답을 받기위해 AddCallback으로 응답으로 올 Packet또는 Message에 대해 미리 callback을 등록해야한다
     * @param packets 서버로 보낼 패킷
     */
    MultiRequest(packets: Array<Packet>): void;
    /**
     * 서버의 Session으로 Packet Array를 보내고, 응답을 기다린다.
     * 응답을 받기위해 AddCallback으로 응답으로 올 Packet또는 Message에 대해 미리 callback을 등록해야한다
     * @param packets 서버로 보낼 패킷
     */
    MultiRequestToGatewaySession(packets: Array<Packet>): void;
    /**
     * 서버로 Packet을 보내고, 응답을 기다린다.
     * @param packet 서버로 보낼 패킷
     * @param callback 응답을 받을 경우 호출될 callback. (선택 사항)
     */
    Request(packet: Packet, callback?: (userAgent: UserAgent, packet: Packet) => void): void;
    /**
     * 서버의 Session으로 Packet을 보내고, 응답을 기다린다.
     * @param packet 서버로 보낼 패킷
     * @param callback 응답을 받을 경우 호출될 callback. (선택 사항)
     */
    RequestToGatewaySession(packet: Packet, callback?: (userAgent: UserAgent, packet: Packet) => void): void;
    /**
     * 서버로 Message를 담은 패킷 보내고, 응답을 기다린다.
     * @param reqMsg 서버로 보낼 Message
     * @param callback 응답을 받을 경우 호출될 callback. (선택 사항)
     */
    RequestPb<T extends IMessage>(reqMsg: IMessage, callback?: (userAgent: UserAgent, resMsg: T) => void): void;
    /**
     * 서버의 Session으로 Message를 담은 패킷 보내고, 응답을 기다린다.
     * @param reqMsg 서버로 보낼 Message
     * @param callback 응답을 받을 경우 호출될 callback. (선택 사항)
     */
    RequestPbToGatewaySession<T extends IMessage>(reqMsg: IMessage, callback?: (userAgent: UserAgent, resMsg: T) => void): void;
    /**
     * 서버로 Message를 담은 패킷 보내고, 응답을 기다린다.
     * RequestPb의 async 버전.
     * @typeparam T 응답으로 받을 Message의 타입
     * @param reqMsg 서버로 보낼 Message
     * @returns 응답으로 받은 Message.
     */
    RequestPbAsync<T extends IMessage>(reqMsg: IMessage): Promise<T>;
    /**
     * 서버의 Session으로 Message를 담은 패킷 보내고, 응답을 기다린다.
     * RequestPbToGatewaySession의 async 버전.
     * @typeparam T 응답으로 받을 Message의 타입
     * @param reqMsg 서버로 보낼 Message
     * @returns 응답으로 받은 Message.
     */
    RequestPbAsyncToGatewaySession<T extends IMessage>(reqMsg: IMessage): Promise<T>;
    /**
     * 서버로 패킷 보내고, 응답을 기다린다.
     * Request의 async 버전.
     * @param packet 서버로 보낼 Packet
     * @returns 응답으로 받은 Packet.
     */
    RequestAsync(packet: Packet): Promise<Packet>;
    /**
     * 서버의 Session으로 패킷 보내고, 응답을 기다린다.
     * RequestToGatewaySession의 async 버전.
     * @param packet 서버로 보낼 Packet
     * @returns 응답으로 받은 Packet.
     */
    RequestAsyncToGatewaySession(packet: Packet): Promise<Packet>;
    /**
     * Error발생시 호출될 Callback을 등록한다.
     * @param callback Error발생시 호출될 Callback
     */
    AddOnError(callback: (agent: UserAgent, errorCode: ErrorCode, command: string) => void): void;
    /**
     * 등록한 모든 Error발생시 호출될 Callback을 등록 해제한다.
     */
    RemoveOnError(): void;
    /**
     * 서비스에 로그인한다.
     * @param userType 로그인에 사용할 UserType
     * @param payload 추가정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param channelId 로그인 할 체널의 ChannelId.
     * @param callback 결과를 전달받을 callback
     */
    Login(userType: string, payload?: Payload, channelId?: string, callback?: (agent: UserAgent, resultCode: ResultCodeLogin, loginInfo: LoginInfo) => void): void;
    /**
     * 서비스에 로그인한다.
     * Login의 Async 버전
     * @param userType 로그인에 사용할 UserType
     * @param payload 추가정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param channelId 로그인 할 체널의 ChannelId.
     * @returns 요청 결과
     */
    LoginAsync(userType: string, payload?: Payload, channelId?: string): Promise<LoginPromise>;
    /**
     * Room 매치를 요청한다. 방이 없을 경우 임의의 방을 생성하고 해당 방에 입장할 수도 있다.
     * @param isCreateRoomIfNotJoinRoom true - 방이 없을 경우 임의의 방을 생성. false - 방이 없을 경우 실패
     * @param isMoveRoomIfJoinedRoom true - 방에 입장한 상태에서 요청했을 경우 다른 방으로 이동. false - 방에 입장한 상태에서 요청했을 경우 실패
     * @param roomType 입장할 방의 roomType.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param leaveRoomPayload 입장한 방을 떠날때 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param callback 결과를 전달받을 callback
     */
    MatchRoom(isCreateRoomIfNotJoinRoom: boolean, isMoveRoomIfJoinedRoom: boolean, roomType: string, payload?: Payload, leaveRoomPayload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeMatchRoom, roomId: string, roomName: string, created: boolean, payload: Payload) => void): void;
    /**
     * Room 매치를 요청한다. 방이 없을 경우 임의의 방을 생성하고 해당 방에 입장할 수도 있다.
     * MatchRoom의 Async 버전
     * @param isCreateRoomIfNotJoinRoom true - 방이 없을 경우 임의의 방을 생성. false - 방이 없을 경우 실패
     * @param isMoveRoomIfJoinedRoom true - 방에 입장한 상태에서 요청했을 경우 다른 방으로 이동. false - 방에 입장한 상태에서 요청했을 경우 실패
     * @param roomType 입장할 방의 roomType.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param leaveRoomPayload 입장한 방을 떠날때 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @returns 요청 결과
     */
    MatchRoomAsync(isCreateRoomIfNotJoinRoom: boolean, isMoveRoomIfJoinedRoom: boolean, roomType: string, payload?: Payload, leaveRoomPayload?: Payload): Promise<MatchRoomPromise>;
    /**
     * 임의의 방을 생성하고 해당 방에 입장한다.
     * @param roomType 생성할 방의 roomType.
     * @param roomName 생성할 방의 이름.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param callback 결과를 전달 받을 callback
     */
    CreateRoom(roomType: string, roomName: string, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeCreateRoom, roomId: string, roomName: string, payload: Payload) => void): void;
    /**
     * 임의의 방을 생성하고 해당 방에 입장한다.
     * CreateRoom의 Async 버전
     * @param roomType 생성할 방의 roomType.
     * @param roomName 생성할 방의 이름.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @returns 요청 결과
     */
    CreateRoomAsync(roomType: string, roomName: string, payload?: Payload): Promise<CreateRoomPromise>;
    /**
     * 지정한 id의 방에 입장한다. 지정한 id의 방이 없을 경우 실패한다.
     * @param roomId 입장하고자 하는 방의 id.
     * @param roomType 입장할 방의 roomType.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param callback 결과를 전달받을 callback
     */
    JoinRoom(roomId: number, roomType: string, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeJoinRoom, roomId: string, roomName: string, payload: Payload) => void): void;
    /**
     * 지정한 id의 방에 입장한다. 지정한 id의 방이 없을 경우 실패한다.
     * JoinRoom의 Async 버전
     * @param roomId 입장하고자 하는 방의 id.
     * @param roomType 입장할 방의 roomType.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @returns 요청 결과
     */
    JoinRoomAsync(roomId: number, roomType: string, payload?: Payload): Promise<JoinRoomPromise>;
    /**
     * 방에 입장했는지 여부를 리턴한다.
     * @returns 방에 입장했을 경우 true, 아닐경우 false
     */
    IsJoinedRoom(): boolean;
    /**
     * 지정한 이름의 방에 입장한다.
     * 지정한 이름의 방이 없을 경우 지정한 이름의 방을 생성하고 해당 방에 입장한다.
     * @param roomName 입장하고자 하는 방의 이름.
     * @param roomType 입장할 방의 roomType.
     * @param isParty true - 파티 매칭을 목적으로 만들어진 방. false - 일반 방.
     * @param payload 서버에 전달할 추가 정보.<br></br>서버 구현에 따라 사용하지 않을 수 있음.
     * @param callback 결과를 전달받을 callback
     */
    NamedRoom(roomName: string, roomType: string, isParty: boolean, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeNamedRoom, roomId: string, roomName: string, created: boolean, payLoad: Payload) => void): void;
    /**
     * 지정한 이름의 방에 입장한다.
     * 지정한 이름의 방이 없을 경우 지정한 이름의 방을 생성하고 해당 방에 입장한다.
     * NamedRoom의 Async 버전
     * @param roomName 입장하고자 하는 방의 이름.
     * @param roomType 입장할 방의 roomType.
     * @param isParty true - 파티 매칭을 목적으로 만들어진 방. false - 일반 방.
     * @param payload 서버에 전달할 추가 정보.<br></br>서버 구현에 따라 사용하지 않을 수 있음.
     * @returns 요청 결과
     */
    NamedRoomAsync(roomName: string, roomType: string, isParty: boolean, payload?: Payload): Promise<NamedRoomPromise>;
    /**
     * PartyMatch를 요청한다.
     * @param roomType 매치를 요청할 roomType.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param callback 결과를 전달받을 callback
     */
    MatchPartyStart(roomType: string, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeMatchPartyStart, payload: Payload) => void): void;
    /**
     * PartyMatch를 요청한다.
     * MatchPartyStart의 Async 버전
     * @param roomType 매치를 요청할 roomType.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @returns 요청 결과
     */
    MatchPartyStartAsync(roomType: string, payload?: Payload): Promise<MatchPartyStartPromise>;
    /**
     * PartyMatch 요청을 취소한다.
     * @param roomType 매치를 요청한 roomType.
     * @param callback 결과를 전달받을 callback
     */
    MatchPartyCancel(roomType: string, callback?: (agent: UserAgent, resultCode: ResultCodeMatchPartyCancel) => void): void;
    /**
     * PartyMatch 요청을 취소한다.
     * MatchPartyCancel의 Async 버전
     * @param roomType 매치를 요청한 roomType.
     * @returns 요청 결과
     */
    MatchPartyCancelAsync(roomType: string): Promise<ResultCodeMatchPartyCancel>;
    /**
     * UserMatch를 요청한다.
     * 이미 방에 입장한 경우 등 서버의 조건에 따라 요청이 실패할 수 있다.
     * 매칭이 성공한 경우 OnMatchUserDone을 통해 알림을 받을 수 있다.
     * @param roomType 매치를 요청할 roomType.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param callback 결과를 전달받을 callback.
     */
    MatchUserStart(roomType: string, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeMatchUserStart, payLoad: Payload) => void): void;
    /**
     * UserMatch를 요청한다.
     * 이미 방에 입장한 경우 등 서버의 조건에 따라 요청이 실패할 수 있다.
     * 매칭이 성공한 경우 OnMatchUserDone을 통해 알림을 받을 수 있다.
     * MatchUserStart의 Async 버전
     * @param roomType 매치를 요청할 roomType.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @returns 요청 결과
     */
    MatchUserStartAsync(roomType: string, payload?: Payload): Promise<MatchUserStartPromise>;
    /**
     * UserMatch 요청을 취소한다.
     * 매치 요청중이 아닌경우, 이미 매칭이 성공했거나 Timeout이 발생했을 경우 실패할 수 있다.
     * @param roomType 매치를 요청한 roomType.
     * @param callback 결과를 전달 받은 callback
     */
    MatchUserCancel(roomType: string, callback?: (agent: UserAgent, resultCode: ResultCodeMatchUserCancel) => void): void;
    /**
     * UserMatch 요청을 취소한다.
     * 매치 요청중이 아닌경우, 이미 매칭이 성공했거나 Timeout이 발생했을 경우 실패할 수 있다.
     * MatchUserCancel의 Async 버전
     * @param roomType 매치를 요청한 roomType.
     * @returns 요청 결과
     */
    MatchUserCancelAsync(roomType: string): Promise<ResultCodeMatchUserCancel>;
    /**
     * 현재 방에서 퇴장한다.
     * @param payload 서버에 전달할 추가 정보.서버 구현에 따라 사용하지 않을 수 있음.
     * @param callback 결과를 전달받을 callback
     */
    LeaveRoom(payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeLeaveRoom, roomId: string, payload: Payload) => void): void;
    /**
     * 현재 방에서 퇴장한다.
     * LeaveRoom의 Async 버전
     * @param payload 서버에 전달할 추가 정보.서버 구현에 따라 사용하지 않을 수 있음.
     * @returns 요청 결과
     */
    LeaveRoomAsync(payload?: Payload): Promise<LeaveRoomPromise>;
    /**
     * 지정한 채널로 이동한다.
     * @param channelId 이동할 channel의 id.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param callback 결과를 전달받을 callback
     */
    MoveChannel(channelId: string, payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeMoveChannel, channelId: string, payload: Payload) => void): void;
    /**
     * 지정한 채널로 이동한다.
     * MoveChannel의 Async 버전
     * @param channelId 이동할 channel의 id.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @returns 요청 결과
     */
    MoveChannelAsync(channelId: string, payload?: Payload): Promise<MoveChannelPromise>;
    /**
     * 현재 user의 snapshot을 얻어온다.
     * 재접속 등 user의 모든 정보를 갱싱해야 할 필요가 있을때 사용할 수 있다.
     * 서버 구현에 따라 내용이 달라진다.
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param callback 결과를 전달받을 callback
     */
    SnapShot(payload?: Payload, callback?: (agent: UserAgent, resultCode: ResultCodeSnapshot, payload: Payload) => void): void;
    /**
     * 현재 user의 snapshot을 얻어온다.
     * 재접속 등 user의 모든 정보를 갱싱해야 할 필요가 있을때 사용할 수 있다.
     * 서버 구현에 따라 내용이 달라진다.
     * SnapShot의 Async 버전
     * @param payload 서버에 전달할 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @returns 요청 결과
     */
    SnapShotAsync(payload?: Payload): Promise<SnapShotPromise>;
    /**
     * 현재 서비스에서 로그아웃 한다.
     * @param callback 결과를 전달받을 callback
     */
    Logout(callback?: (agent: UserAgent, resultCode: ResultCodeLogout, payload: Payload) => void): void;
    /**
     * 현재 서비스에서 로그아웃 한다.
     * Logout의 Async 버전
     * @returns 요청 결과
     */
    LogoutAsync(): Promise<LogoutPromise>;
}
/**
 * 로그인 정보.
 */
export class LoginInfo {
    /** 로그인한 유저의 Id */
    userId: number;
    /** 로그인한 유저의 type */
    userType: string;
    /** 로그인한 체널의 Id */
    channelId: string;
    /** 로그인한 서비스의 이름 */
    serviceName: string;
    /** 서버로부터 받은 추가정보. */
    payload: Payload;
    /** 서버로부터 받은 Message. 로그인 실패 이유 등. */
    message: string;
    /** 재로그인 여부. */
    isRelogined: boolean;
    /** 방에 입장 여부. */
    isJoinedRoom: boolean;
    /** 입장한 방의 RoomId. */
    roomId: number;
    /** 입장한 방의 RoomName. */
    roomName: string;
    /** 입장한 방에 필요한 추가정보. */
    roomPayload: Payload;
    /** 매칭을 요청한 상태인지 여부. */
    isMatching: boolean;
    constructor(
        /** 로그인한 유저의 Id */
        userId: number,
        /** 로그인한 유저의 type */
        userType: string,
        /** 로그인한 체널의 Id */
        channelId: string,
        /** 로그인한 서비스의 이름 */
        serviceName: string,
        /** 서버로부터 받은 추가정보. */
        payload: Payload,
        /** 서버로부터 받은 Message. 로그인 실패 이유 등. */
        message: string,
        /** 재로그인 여부. */
        isRelogined: boolean,
        /** 방에 입장 여부. */
        isJoinedRoom: boolean,
        /** 입장한 방의 RoomId. */
        roomId: number,
        /** 입장한 방의 RoomName. */
        roomName: string,
        /** 입장한 방에 필요한 추가정보. */
        roomPayload: Payload,
        /** 매칭을 요청한 상태인지 여부. */
        isMatching: boolean);
}
/** LoginAsync 결과 */
export class LoginPromise {
    /** 결과 코드 */
    resultCode: ResultCodeLogin;
    /** 로그인 정보 */
    loginInfo: LoginInfo;
    constructor(
        /** 결과 코드 */
        resultCode: ResultCodeLogin,
        /** 로그인 정보 */
        loginInfo: LoginInfo);
}
/** MatchRoomAsync 결과 */
export class MatchRoomPromise {
    /** 결과 코드 */
    resultCode: ResultCodeMatchRoom;
    /** 매치된 방의 RoomId  */
    roomId: string;
    /** 매치된 방의 이름  */
    roomName: string;
    /** 매치된 방의 생성 여부(방장 여부)  */
    created: boolean;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeMatchRoom, 
    /** 매치된 방의 RoomId  */
    roomId: string, 
    /** 매치된 방의 이름  */
    roomName: string, 
    /** 매치된 방의 생성 여부(방장 여부)  */
    created: boolean, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload);
}
/** CreateRoomAsync 결과 */
export class CreateRoomPromise {
    /** 결과 코드 */
    resultCode: ResultCodeCreateRoom;
    /** 생성한 방의 RoomId */
    roomId: string;
    /** 생성한 방의 이름 */
    roomName: string;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeCreateRoom, 
    /** 생성한 방의 RoomId */
    roomId: string, 
    /** 생성한 방의 이름 */
    roomName: string, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload);
}
/** JoinRoomAsync 결과 */
export class JoinRoomPromise {
    /** 결과 코드 */
    resultCode: ResultCodeJoinRoom;
    /** 입장한 방의 RoomId */
    roomId: string;
    /** 입장한 방의 이름 */
    roomName: string;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeJoinRoom, 
    /** 입장한 방의 RoomId */
    roomId: string, 
    /** 입장한 방의 이름 */
    roomName: string, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload);
}
/** NamedRoomAsync 결과 */
export class NamedRoomPromise {
    /** 결과 코드 */
    resultCode: ResultCodeNamedRoom;
    /** 입장한 방의 RoomId */
    roomId: string;
    /** 입장한 방의 이름 */
    roomName: string;
    /** 입장한 방을 생성했는지 여부.(방장 여부) */
    created: boolean;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
    /** 결과 코드 */
    resultCode: ResultCodeNamedRoom, 
    /** 입장한 방의 RoomId */
    roomId: string, 
    /** 입장한 방의 이름 */
    roomName: string, 
    /** 입장한 방을 생성했는지 여부.(방장 여부) */
    created: boolean, 
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload);
}
export class MatchPartyStartPromise {
    /** 결과 코드 */
    resultCode: ResultCodeMatchPartyStart;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
        /** 결과 코드 */
        resultCode: ResultCodeMatchPartyStart,
        /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
        payload: Payload);
}
export class MatchUserStartPromise {
    /** 결과 코드 */
    resultCode: ResultCodeMatchUserStart;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
        /** 결과 코드 */
        resultCode: ResultCodeMatchUserStart,
        /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
        payload: Payload);
}
export class LeaveRoomPromise {
    /** 결과 코드 */
    resultCode: ResultCodeLeaveRoom;
    /** 퇴장한 방의 RoomId */
    roomId: string;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
        /** 결과 코드 */
        resultCode: ResultCodeLeaveRoom,
        /** 퇴장한 방의 RoomId */
        roomId: string,
        /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
        payload: Payload);
}
export class MoveChannelPromise {
    /** 결과 코드 */
    resultCode: ResultCodeMoveChannel;
    /** 이동한 체널의 ChannelId */
    channelId: string;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
        /** 결과 코드 */
        resultCode: ResultCodeMoveChannel,
        /** 이동한 체널의 ChannelId */
        channelId: string,
        /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
        payload: Payload);
}
export class LogoutPromise {
    /** 결과 코드 */
    resultCode: ResultCodeLogout;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
        /** 결과 코드 */
        resultCode: ResultCodeLogout,
        /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
        payload: Payload);
}
export class SnapShotPromise {
    /** 결과 코드 */
    resultCode: ResultCodeSnapshot;
    /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
    payload: Payload;
    constructor(
        /** 결과 코드 */
        resultCode: ResultCodeSnapshot,
        /** 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음. */
        payload: Payload);
}

export interface IAgent {
}
/** ConnectionAgent의 모든 결과 또는 알림 인터페이스 */
export interface IConnectionListener {
    /**
     * Connect의 결과
     * @param session ConnectionAgent 인스턴스
     * @param resultCode Connect의 결과 코드
     */
    OnConnect?(session: ConnectionAgent, resultCode: ResultCodeConnect): void;
    /**
     * Authentication의 결과
     * @param session ConnectionAgent 인스턴스
     * @param resultCode Authentication의 결과 코드
     * @param loginedUserInfoList 서버에 남아있는 로그인 정보 목록
     * @param message 서버로부터 받은 Message. 인증 실패 이유 등.
     * @param payload 추가 정보
     */
    OnAuthentication?(session: ConnectionAgent, resultCode: ResultCodeAuth, loginedUserInfoList: Array<LoginedUserInfo>, message: string, payload: Payload): void;
    /**
     * GetChannelList의 결과
     * @param session ConnectionAgent 인스턴스
     * @param resultCode GetChannelList의 결과 코드
     * @param channelIdList 체널 목록
     */
    OnChannelList?(session: ConnectionAgent, resultCode: ResultCodeChannelList, channelIdList: Array<string>): void;
    /**
     * GetChannelInfo의 결과
     * @param session ConnectionAgent 인스턴스
     * @param resultCode GetChannelInfo의 결과 코드
     * @param channelInfoList 체널 정보 목록
     */
    OnChannelInfo?(session: ConnectionAgent, resultCode: ResultCodeChannelInfo, channelInfoList: Array<Payload>): void;
    /**
     * Disconnect의 결과 또는 또는 강제 접속종료 알림
     * @param session ConnectionAgent 인스턴스
     * @param resultCode Disconnect의 결과 코드
     * @param reason 종료 이유. ConnectionAgent.Disconnect()에 인자로 넘긴 reason.
     * @param force 강제 종료 여부
     * @param payload 추가 정보
     */
    OnDisconnect?(session: ConnectionAgent, resultCode: ResultCodeDisconnect, reason: string, force: boolean, payload: Payload): void;
    /**
     * Error발생
     * @param session ConnectionAgent 인스턴스
     * @param errorCode 에러 코드
     * @param msgName 에러가 발생한 Message의 이름
     */
    OnErrorCommand?(session: ConnectionAgent, errorCode: ErrorCode, msgName: string): void;
}
/** UserListener에서 Login의 결과를 위한 인터페이스 */
export interface IUserListener {
    /**
     * Login의 결과.
     * @param user Login을 요청한 UserAgent 객체
     * @param resultCode Login 결과 코드
     * @param loginInfo Login 정보
     */
    OnLogin?(user: UserAgent, resultCode: ResultCodeLogin, loginInfo: LoginInfo): void;
    /**
     *
     * @param user
     * @param resultCode
     * @param force
     * @param payload
     */
    OnLogout?(user: UserAgent, resultCode: ResultCodeLogout, force: boolean, payload: Payload): void;
    /**
     * MatchRoom의 결과
     * @param user MatchRoom을 요청한 UserAgent 객체
     * @param resultCode MatchRoom 결과 코드
     * @param roomId 매치된 방의 RoomId
     * @param roomName 매치된 방의 이름
     * @param created 매치된 방의 생성여부.(방장 여부)
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnMatchRoom?(user: UserAgent, resultCode: ResultCodeMatchRoom, roomId: number, roomName: string, created: boolean, payload: Payload): void;
    /**
     * CreateRoom의 결과
     * @param user CreateRoom을 요청한 UserAgent 객체
     * @param resultCode CreateRoom 결과 코드
     * @param roomId 생성된 방의 RoomId
     * @param roomName 생성된 방의 이름
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnCreateRoom?(user: UserAgent, resultCode: ResultCodeCreateRoom, roomId: number, roomName: string, payload: Payload): void;
    /**
     * JoinRoom의 결과
     * @param user JoinRoom을 요청한 UserAgent 객체
     * @param resultCode JoinRoom 결과 코드
     * @param roomId 입장한 방의 RoomId
     * @param roomName 입장한 방의 이름
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnJoinRoom?(user: UserAgent, resultCode: ResultCodeJoinRoom, roomId: number, roomName: string, payload: Payload): void;
    /**
     * NamedRoom의 결과
     * @param user NamedRoom을 요청한 UserAgent 객체
     * @param resultCode NamedRoom 결과 코드
     * @param roomId 입장한 방의 RoomId.
     * @param roomName 입장한 방의 이름.
     * @param created 입장한 방을 생성했는지 여부.(방장 여부)
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnNamedRoom?(user: UserAgent, resultCode: ResultCodeNamedRoom, roomId: number, roomName: string, created: boolean, payload: Payload): void;
    /**
     * LeaveRoom의 결과
     * @param user 방에서 퇴장한 UserAgent 객체
     * @param resultCode LeaveRoom 결과 코드
     * @param force 강퇴 여부
     * @param roomId 퇴장한 방의 RoomId
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnLeaveRoom?(user: UserAgent, resultCode: ResultCodeLeaveRoom, force: boolean, roomId: number, payload: Payload): void;
    /**
     * MatchUserStart의 결과
     * @param user MatchUserStart를 요청한 UserAgent 객체
     * @param resultCode MatchUserStart 결과 코드
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnMatchUserStart?(user: UserAgent, resultCode: ResultCodeMatchUserStart, payload: Payload): void;
    /**
     * MatchUserCancel의 결과
     * @param user MatchUserCancel을 요청한 UserAgent 객체
     * @param resultCode MatchUserCancel 결과 코드
     */
    OnMatchUserCancel?(user: UserAgent, resultCode: ResultCodeMatchUserCancel): void;
    /**
     * MatchUserStart, MatchPartyStart의 매칭 결과
     * @param user 매칭을 요청한 UserAgent 객체
     * @param resultCode 매칭 결과 코드
     * @param created 방 생성 여부. true일 경우 매칭 요청한 UserAgent가  방을 생성한 것을 의미한다. 방장을 결정하는 용도 등으로 사용할 수 있다.
     * @param roomId 매칭된 방의 RoomId
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnMatchUserDone?(user: UserAgent, resultCode: ResultCodeMatchUserDone, created: boolean, roomId: number, payload: Payload): void;
    /**
     * MatchUserStart, MatchPartyStart의 매칭의 Timeout
     * @param user 매칭을 요청한 UserAgent 객체
     */
    OnMatchUserTimeout?(user: UserAgent): void;
    /**
     * MatchPartyStart의 결과
     * @param user MatchPartyStart을 요청한 UserAgent 객체
     * @param resultCode MatchPartyStart 결과 코드
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnMatchPartyStart?(user: UserAgent, resultCode: ResultCodeMatchPartyStart, payload: Payload): void;
    /**
     * MatchPartyCancel의 결과
     * @param user MatchPartyCancel을 요청한 UserAgent 객체
     * @param resultCode MatchPartyCancel의 결과 코드
     */
    OnMatchPartyCancel?(user: UserAgent, resultCode: ResultCodeMatchPartyCancel): void;
    /**
     * MoveChannel의 결과 또는 서버에서 강제로 수행한 체널 이동 알림
     * @param user 체널을 이동한 UserAgent 객체
     * @param resultCode 체널이동 결과 코드
     * @param force 서버에서 강제로 체널을 이동했는지 여부
     * @param channelId 이동한 체널의 ChannelId
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnMoveChannel?(user: UserAgent, resultCode: ResultCodeMoveChannel, force: boolean, channelId: string, payload: Payload): void;
    /**
     * Snapshot의 결과
     * @param user Snapshot을 요청한 UserAgent 객체
     * @param resultCode Snapshot의 결과 코드
     * @param paload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     */
    OnSnapshot?(user: UserAgent, resultCode: ResultCodeSnapshot, paload: Payload): void;
    /**
     * Error발생
     * @param user Error가 발생한 UserAgent 객체
     * @param errorCode Error 코드
     * @param msgName Error가 발생한 기능 또는 Message
     */
    OnErrorCommand?(user: UserAgent, errorCode: ErrorCode, msgName: string): void;
    /**
     * Notice 알림
     * @param user Notice 를 받은 UserAgent 객체
     * @param message Notice message
     */
    OnNotice?(user: UserAgent, message: string): void;
    /**
     * Admin에서 Kickout한 경우 알림
     * @param user Kickout된 UserAgent객체
     * @param message Admin에서 전달한 Message
     */
    OnAdminKickoutNoti?(user: UserAgent, message: string): void;
}

/**
 * ConnectionAgent는 GameAnvil Server의 Session Node와 관련된 작업을 담당한다.
 * 접속(Connect()), 인증(Authentication()) 등 기본 세션 관리 기능 및 채널 목록 등을 제공하며,
 * 서버 구현에 따라 채널 정보를 제공하거나 사용자 정의 기능을 추가적으로 제공할 수도 있다.
 * ConnectionAgent는 Connector가 초기화 될 때 자동으로 생성되며 GetConnectionAgent() 함수를 이용해 얻을 수 있다.
 *
 * ConnectionAgent가 제공하는 기본 기능은 모두 비동기 함수를 통해 제공된다.
 * 그리고 각 기능의 결과를 얻기 위해 크게 나눠 2가지 방식을 제공하고 있다.
 * 첫째는 listener나 delegate를 미리 등록해 놓고 이를 통해 결과에 대한 알림을 받는 방법이고,
 * 나머지는 기능을 요청 할 때 알림을 받을 delegate를 같이 전달하는 방법이다.
 * 두가 방법을 같이 사용하는 것도 가능하고 목적에 따라 listener나 delegate는 여러개를 등록하여 사용할 수도 있다.
 */
export class ConnectionAgent {
    /**
     * 인증시 사용한 AccountId를 리턴한다.
     * @returns 인증시 사용한 AccountId
     */
    GetAccountId(): string;
    /**
     * 서버 접속 여부를 리턴한다.
     * @returns 서버에 접속한 경우 true, 아닌 경우 false
     */
    IsConnected(): boolean;
    /**
     * 임의의 Id에 대한 callback을 등록한다.
     * 해당 Id의 패킷을 수신한 경우 등록된 callback이 호출된다.
     * @param resMsgIndex 응답으로 받을 패킷의 임의의 Id
     * @param callback callback
     */
    AddUndefinedProtocolCallback(resMsgIndex: number, callback: (agent: ConnectionAgent, packet: Packet) => void): void;
    /**
     * 임의의 Id에 대해 등록한 모든 callback을 등록 해제한다.
     * @param resMsgIndex 등록한 임의의 Id
     */
    RemoveUndefinedProtocolCallback(resMsgIndex: number): void;
    /**
     * 특정 Message에 대한 callback을 등록한다.
     * 특정 Message의 패킷을 수신한 경우 등록된 callback이 호출된다.
     * @param message 응답으로 받을 패킷에 담긴 Message
     * @param callback callback
     */
    AddCallback<T extends IMessage>(message: new () => T, callback: (agent: ConnectionAgent, msg: T) => void): void;
    /**
     * ISessionListener를 상속받은 SessionListener를 등록한다.
     * @param listener ISessionListener를 상속받은 SessionListener
     */
    AddListener(listener: IConnectionListener): void;
    /**
     * 특정 Message에 대해 등록한 모든 callback을 등록 해제한다.
     * @param message 등록한 Message
     */
    RemoveCallback<T extends IMessage>(message: new () => T): void;
    /**
     * 등록한 SessionListener를 등록 해제한다.
     * @param listener 등록한 SessionListener
     */
    RemoveListener(listener: IConnectionListener): void;
    /**
     * 서버로 Packet을 보낸다
     * @param packet 서버로 보낼 패킷
     */
    Send(packet: Packet): void;
    /**
     * 서버로 Message를 담은 패킷 보낸다.
     * @param reqMsg 서버로 보낼 Message
     */
    SendPb<T extends IMessage>(reqMsg: IMessage): void;
    /**
     * 서버로 Packet을 보내고, 응답을 기다린다.
     * @param packet 서버로 보낼 패킷
     * @param callback 응답을 받을 경우 호출될 callback. (선택 사항)
     */
    Request(packet: Packet, callback?: (connectionAgent: ConnectionAgent, packet: Packet) => void): void;
    /**
     * 서버로 Message를 담은 패킷 보내고, 응답을 기다린다.
     * @param msg 서버로 보낼 Message
     * @param callback 응답을 받을 경우 호출될 callback. (선택 사항)
     */
    RequestPb<T extends IMessage>(msg: IMessage, callback?: (connectionAgent: ConnectionAgent, resMsg: T) => void): void;
    /**
     * 서버로 Message를 담은 패킷 보내고, 응답을 기다린다.
     * RequestPb의 async 버전.
     * @typeparam T 응답으로 받을 Message의 타입
     * @param reqMsg 서버로 보낼 Message
     * @returns 응답으로 받은 Message.
     */
    RequestPbAsync<T extends IMessage>(reqMsg: IMessage): Promise<T>;
    /**
     * 서버로 패킷 보내고, 응답을 기다린다.
     * Request의 async 버전.
     * @param packet 서버로 보낼 Packet
     * @returns 응답으로 받은 Packet.
     */
    RequestAsync(packet: Packet): Promise<Packet>;
    /**
     * Error발생시 호출될 Callback을 등록한다.
     * @param callback Error발생시 호출될 Callback
     */
    AddOnError(callback: (agent: ConnectionAgent, errorCode: ErrorCode, command: string) => void): void;
    /**
     * 등록한 모든 Error발생시 호출될 Callback을 등록 해제한다.
     */
    RemoveOnError(): void;
    /**
     * GameAnvil Server에 연결한다.
     * @param ipAdress 연결할 서버의 주소. (ws://127.0.0.1:11400/gameanvil)
     * @param callback 결과를 전달받을 callback
     */
    Connect(ipAdress: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeConnect) => void): void;
    /**
     * GameAnvil Server에 연결한다.
     * Connect의 Async 버전
     * @param ipAdress 연결할 서버의 주소. (ws://127.0.0.1:11400/gameanvil)
     * @returns 결과 코드
     */
    ConnectAsync(ipAdress: string): Promise<ResultCodeConnect>;
    /**
     * GameAnvil Server에 인증을 요청한다.
     * 인증에 성공해야 GameAnvil Connector의 다른 기능을 사용할 수 있다.
     * @param deviceId 사용자 기기를 식별 할 수 있는 고유 ID. 같은 사용자의 중복 접속을 체크하는데 사용된다. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param accountId 사용자 계정을 식별 할 수 있는 고유 ID.
     * @param password 사용자 계정의 password. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param callback 결과를 전달받을 callback
     */
    Authenticate(deviceId: string, accountId: string, password: string, payload?: Payload, callback?: (agent: ConnectionAgent, resultCode: ResultCodeAuth, loginedUserInfoList: Array<LoginedUserInfo>, message: string, payload: Payload) => void): void;
    /**
     * GameAnvil Server에 인증을 요청한다.
     * 인증에 성공해야 GameAnvil Connector의 다른 기능을 사용할 수 있다.
     * Authenticate의 Async 버전
     * @param deviceId 사용자 기기를 식별 할 수 있는 고유 ID. 같은 사용자의 중복 접속을 체크하는데 사용된다. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param accountId 사용자 계정을 식별 할 수 있는 고유 ID.
     * @param password 사용자 계정의 password. 서버 구현에 따라 사용하지 않을 수 있음.
     * @param payload 추가 정보. 서버 구현에 따라 사용하지 않을 수 있음.
     * @returns 인증 요청 결과.
     */
    AuthenticateAsync(deviceId: string, accountId: string, password: string, payload?: Payload): Promise<AuthenticatePromis>;
    /**
     * 특정 서비스에서 사용 가능한 채널 목록을 요청한다.
     * @param serviceName 채널 정보를 요청할 서비스의 serviceName
     * @param callback 결과를 전달 받을 callback.
     */
    GetChannelList(serviceName: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeChannelList, channelIdList: Array<string>) => void): void;
    /**
     * 특정 서비스에서 사용 가능한 채널 목록을 요청한다.
     * GetChannelList의 async 버전
     * @param serviceName 채널 정보를 요청할 서비스의 serviceName
     * @returns 채널 목록을 요청 요청 결과.
     */
    GetChannelListAsync(serviceName: string): Promise<GetChannelListPromis>;
    /**
     * 특정 채널의 정보를 요청한다. 서버에서 지원할 경우 사용할 수 있다.
     * @param serviceName 채널 정보를 요청할 서비스의 serviceName
     * @param channelId 채널 정보를 요청할 체널의 ChannelId
     * @param callback 결과를 전달받을 callback
     */
    GetChannelInfo(serviceName: string, channelId: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeChannelInfo, channelInfoList: Array<Payload>) => void): void;
    /**
     * 특정 채널의 정보를 요청한다. 서버에서 지원할 경우 사용할 수 있다.
     * GetChannelInfo의 Async 버전
     * @param serviceName 채널 정보를 요청할 서비스의 serviceName
     * @param channelId 채널 정보를 요청할 체널의 ChannelId
     * @returns 채널의 정보를 요청 결과
     */
    GetChannelInfoAsync(serviceName: string, channelId: string): Promise<GetChannelInfoPromise>;
    /**
     * 접속 종료시 호출될 Callback을 등록한다.
     * @param callback 접속 종료시 호출될 Callback
     */
    AddOnDisconnect(callback: (session: ConnectionAgent, resultCode: ResultCodeDisconnect, reason: string, force: boolean, payload: Payload) => void): void;
    /**
     * 등록한 접속 종료시 호출될 Callback을 모두 등록 해제 한다.
     */
    RemoveOnDisconnect(): void;
    /**
     * GameAnvil Server와의 연결을 해제한다.
     * @param reason callback에 전달할 연결 해제 이유.
     * @param callback 접속 종료시 호출될 callback
     */
    Disconnect(reason: string, callback?: (agent: ConnectionAgent, resultCode: ResultCodeDisconnect, reason: string) => void): void;
}
/**
 * 인증 성공시, 서버에 남아있는 로그인된 유저정보.
 */
export class LoginedUserInfo {
    /** SubId */
    subId: number;
    /** Service 이름 */
    serviceName: string;
    /** UserId */
    userId: number;
    /** UserType */
    userType: string;
    /** Channel Id */
    channelId: string;
    /** Payload */
    payload: Payload;
    constructor(
        /** SubId */
	    subId: number, 
	    /** Service 이름 */
	    serviceName: string, 
	    /** UserId */
	    userId: number, 
	    /** UserType */
	    userType: string, 
	    /** Channel Id */
	    channelId: string, 
	    /** Payload */
	    payload: Payload);
}
/**
 * AuthenticateAsync의 요청 결과
 */
export class AuthenticatePromis {
    /** 결과 코드 */
    resultCode: ResultCodeAuth;
    /** 서버에 남아있는 로그인 정보 목록 */
    loginedUserInfoList: Array<LoginedUserInfo>;
    /** 서버로부터 받은 Message. 인증 실패 이유 등. */
    message: string;
    /** 추가 정보 */
    payload: Payload;
    constructor(
        /** 결과 코드 */
        resultCode: ResultCodeAuth,
        /** 서버에 남아있는 로그인 정보 목록 */
        loginedUserInfoList: Array<LoginedUserInfo>,
        /** 서버로부터 받은 Message. 인증 실패 이유 등. */
        message: string,
        /** 추가 정보 */
        payload: Payload);
}
/**
 * GetChannelListAsync의 요청 결과.
 */
export class GetChannelListPromis {
    /** 결과 코드 */
    resultCode: ResultCodeChannelList;
    /** 체널 목록 */
    channelIdList: Array<string>;
    constructor(
        /** 결과 코드 */
        resultCode: ResultCodeChannelList,
        /** 체널 목록 */
        channelIdList: Array<string>);
}
/**
 * GetChannelInfoAsync의 요청 결과
 */
export class GetChannelInfoPromise {
    /** 결과 코드 */
    resultCode: ResultCodeChannelInfo;
    /** 체널 정보 목록 */
    channelInfoList: Array<Payload>;
    constructor(
        /** 결과 코드 */
        resultCode: ResultCodeChannelInfo,
        /** 체널 정보 목록 */
        channelInfoList: Array<Payload>);
}


/**
 * 커넥터 환경값.
 */
export class Config {
    /**
     * TimeOut 기본 대기시간 설정(단위 : sec, 기본값 3).
     */
    DefaultRequestTimeout: number;
    /**
     * 서버와의 연결을 확인하기 위한 ping 주기 설정(단위 : sec, 0일 경우 사용 안함, 기본값 : 3).
     */
    PingInterval: number;
    /**
     * 패킷이 지정된 시간안에 업데이트 되지 않으면, disconnect 되었다고 판단된다.
     * pingInterval 보다 높게 설정되야 한다. (기본값 : 5)
     */
    PacketTimeout: number;
}

/**
 * Connector는 GameAnvil Connector를 사용하기 위한 기본 클래스다.
 * 기본 설정과 Agent의 관리를 담당한다.
 * 또 내부 동작과 관련된 로그를 볼수 있도록 delegate를 등록할 수 있다.
 */
export class Connector {
    /**
     * 커넥터 환경값.
     */
    config: Config;
    /**
     * Connector의 새 인스턴스를 생성하여 리턴한다.
     * @returns Connector의 새 인스턴스;
     */
    static Create(): Connector;
    /**
     * 유저 에이전트 생성.
     * @param serviceName UserAgent가 사용 할 serviceName.
     * @param subId 서비스별 UserAgent를 식별 할 수 있는 고유 ID. 서버 구현에 따라 사용하지 않을 수 있음.
     * @returns UserAgent 생성된 유저 에이전트.
     */
    CreateUserAgent(serviceName: string, subId: number): UserAgent;
    /**
     * 모든 유저 에이전트를 넘겨준다.
     * @returns Array<UserAgent> 모든 유저 에이전트.
     */
    GetUserAgents(): Array<UserAgent>;
    /**
     * 유저 에이전트를 찾아 가져온다.
     * @param serviceName UserAgent가 사용하는 serviceName.
     * @param subId 서비스별 UserAgent를 식별 할 수 있는 고유 ID. 서버 구현에 따라 사용하지 않을 수 있음.
     * @returns UserAgent 해당 유저 에이전트, 없으면 null
     */
    GetUserAgent(serviceName: string, subId: number): UserAgent;
    /**
     * 컨넥션 에이전트를 넘겨준다.
     * @returns ConnectionAgent 컨넥션 에이전트
     */
    GetConnectionAgent(): ConnectionAgent;
    /**
     * 메세지의 처리를 위한 함수. 주기적으로 호출해주어야 한다.
     */
    Update(): void;
}